// More information about this indicator can be found at:
//http://fxcodebase.com/code/viewtopic.php?f=38&t=65882

//+------------------------------------------------------------------+
//|                               Copyright ?2018, Gehtsoft USA LLC | 
//|                                            http://fxcodebase.com |
//+------------------------------------------------------------------+
//|                                      Developed by : Mario Jemic  |                    
//|                                          mario.jemic@gmail.com   |
//+------------------------------------------------------------------+
//|                                 Support our efforts by donating  | 
//|                                    Paypal: https://goo.gl/9Rj74e |
//+------------------------------------------------------------------+
//|                    BitCoin : 15VCJTLaz12Amr7adHSBtL9v8XomURo9RF  |  
//|                BitCoin Cash: 1BEtS465S3Su438Kc58h2sqvVvHK9Mijtg  | 
//|           Ethereum : 0x8C110cD61538fb6d7A2B47858F0c0AaBd663068D  |  
//|                   LiteCoin : LLU8PSY2vsq7B9kRELLZQcKf5nJQrdeqwD  |  
//+------------------------------------------------------------------+


#property copyright "Copyright ?2018, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"
#property version "1.0"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  clrRed
#property indicator_color2  clrYellow

 
extern int Period1=14; 
extern int MaPeriod = 10;
extern ENUM_MA_METHOD MaMode = MODE_EMA;
 

double Line[],Line2[];
double Temp[];


int init()
{
 
   IndicatorDigits(_Digits);
   IndicatorBuffers(3);
   SetIndexBuffer(0,Line); SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,Line2);SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(2,Temp);
   IndicatorShortName("Time Segmented Volume");
return(0);
}

int deinit()
{

 return(0);
}

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
  
   for (int i=limit; i>=0; i--)
   {
      Temp[i]=0;
      if(Close[i]> Close[i+1]) 
      {
        Temp[i]=  Volume[i] * (Close[i]- Close[i+1]);
      }
  
     if(Close[i]< Close[i+1]) 
     {
       Temp[i]=  -1* Volume[i] * (Close[i+1]- Close[i]);
     }
      Line[i]=iMAOnArray(Temp,0,Period1,0,MODE_SMA,i)*Period1;
  } 
  for (i=limit; i>=0; i--) Line2[i] = iMAOnArray(Line,0,MaPeriod,0,MaMode,i);

 return(0);
}

